if(!dojo._hasResource["com.ibm.customize.CustomizeController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.customize.CustomizeController"] = true;
 // This is an API for controllers that customize the look of a page

dojo.provide("com.ibm.customize.CustomizeController");
dojo.declare("com.ibm.customize.CustomizeController",
	[dijit._Widget],
	{
		dirty: false,		// true if there are changes pending
		started: false,		// true if the widget is started up
		refresh: true,		// true if a page refresh is required to show saved changes
		tabLabel: "",		// the name of the controller for the UI
		domNode: null,		// the root node for the controller's UI
		
		startup: function(){
			// summary: does any necessary preliminary work
			this.started = true;
			this.setupUI();
		},
		
		setupUI: function(){
			// summary: sets up the UI for the controller
		},
		
		makeDirty: function(/*bool*/change){
			// summary: changes the dirty attribute
			// change: value to assign to the dirty attribute
			this.dirty = change;
		},
		
		processChange: function(/*Object*/args){
			// summary: used as an event handler for when a user clicks on an item
			// args: associative array produced by mapItem() in the datastore mixed in with {hub:datastore for item, item:item}
			this.apply(args);
		},
		
		apply: function(/*Object*/args){
			// summary: applies a change associated with a selected item to the page
			// args: associative array produced by mapItem() in the datastore
		},
		
		undo: function(){
			// summary: reverts any changes made from this controller
			if(this.dirty) this.makeDirty(false);
		},
		
		beforeSubmit: function(/*Object*/args){
			// summary: Called before submit and returns a Deferred object which should be used
			// 		to get notified when the controller is ready to be submitted.  Attach a callback
			//		to this Deferred to call the controller's submit function instead of calling
			//		it directly.
			// args: {onError:function to call if there is an error}
			var dfd = new dojo.Deferred();
			dfd.callback		
			return dfd;
		},
		
		submit: function(/*Object*/args){
			// summary: saves any pending changes
			// args: {onComplete:function to call when done submitting, onError:function to call if there is an error}
			if(this.dirty) this.makeDirty(false);
			if(args.onComplete) args.onComplete();
		}
});

}
