if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceCategorySelector"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceCategorySelector"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceCategorySelector");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerAwareMixin");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.ModelAwareMixin");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");

dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceCategorySelector", 
		[dijit._Widget, dijit._Templated], 
{
	templatePath : dojo.moduleUrl("com.ibm.mm.builder", "iwidget/spacemanager/widget/templates/SpaceCategorySelector.html"),
	
	constructor : function() {
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
	},
	
	postMixInProperties : function() {
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
		dojo.mixin(this, this._bundle);
	},
	
	postCreate : function() {
		this.inherited(arguments);
		this._render();
	},
	
	_render : function() {
		this._setupCategories();
	},
	
	_setupCategories : function() {
		this._categories = [];
		dojo.query("ul > li", this.domNode).forEach(function(li) {
			this._categories.push(li);
			this.connect(dojo.query("a", li)[0], "onclick", this._categoryClicked);
			if (dojo.hasClass(li, "lotusSelected")) {
				this._selectedCategory = li;
			}
		}, this);
	},
	
	_categoryClicked : function(event) {
		if (!event) {
			return;
		}
		var node = event.target;
		if (node && node.parentNode) {
			var liNode = node.parentNode;
			if (this._selectedCategory === liNode) {
				return;
			}
			dojo.addClass(liNode, "lotusSelected");
			dojo.attr(liNode, "aria-selected", "true");
			var isSelected = dojo.doc.createElement("span");
			dojo.addClass(isSelected,"access");
			isSelected.appendChild(dojo.doc.createTextNode(this.I_MODE_IS_SELECT));
			node.appendChild(isSelected);
						
			dojo.removeClass(this._selectedCategory, "lotusSelected");
			dojo.attr(this._selectedCategory, "aria-selected", "false");
			dojo.forEach(
				dojo.query(".access",this._selectedCategory),
				dojo.hitch(this, function(item){
					item.parentNode.removeChild(item);
				})
			);
						
			this._selectedCategory = liNode;
			this.selectCategory(dojo.attr(liNode, "_type"));
		}
		dojo.stopEvent(event);
	},
	
	selectCategory : function(category) {
		dojo.publish(this._constants.Topic.Category.change, [category,true]);
	}
});

}
