if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpacesList"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpacesList"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.SpacesList");
dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.SpacesList", 
		[dijit._Widget, dijit._Templated], {
	templateString : "<div class='spaces_list' aria-live='polite' aria-relevant='all'></div>",
	
	constructor : function() {
		this.enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this.spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
		this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
	},

	postCreate : function() {
		dojo.addClass(this.domNode, this.spacesListType);
		dojo.attr(this.domNode, "spaces_list_type", this.spacesListType);
	},
	
	_isHiddenSpace : function(space) {
		return space.isHidden();
	},
	
	_canEditSpace : function(space) {
		return this.spaceUtil.canEdit(space);
	},
	
	refresh : function(spaceIter) {
		var containerNode = this.domNode;
		containerNode.innerHTML = this.spaceManagerUtil.ui.getLoadingNodeHtml();
		this.spaceManagerUtil.util.delayCall(dojo.hitch(this, this._loadSpaces, spaceIter));
	},
	
	_spaceItems: [],
	
	_loadSpaces : function(spaceIter) {
		var hasSpaces = false;		
		spaceIter.setCursorPosition(0);
		
		// memory leak : also remove the spaceItem
		for(var i=0; i<this._spaceItems.length; i++) {
			var _si = this._spaceItems[i];
			_si.destroy();
		}
		this._spaceItems.length = 0;
		
		var containerNode = this.domNode;
		containerNode.innerHTML = "";
		
		var mpFactory = com.ibm.mashups.enabler.io.XHRMultipartFactory;
		var mpHandler = mpFactory.create();
		mpHandler.startTransaction(mpFactory.CONTEXT_ENABLER);
		
		while (spaceIter.hasNext()) {
			hasSpaces = true;
			var space = spaceIter.next();
			if (!this._isHiddenSpace(space) || this._canEditSpace(space)) {
				var node = dojo.create("div", {}, containerNode);
				
				var spaceItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceItem({
					spaceMeta: {
						title: this.enablerUtil.getNodeTitle(space) || this._bundle.I_SPACE_MANAGER_NO_TITLE,
						description: this.enablerUtil.getNodeDescription(space) || this._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
						iconUrl: this.spaceUtil.getSpaceIconURL(space),
						owner: null, // will be loaded asynchronously by the space item later
						pagesNum: this._bundle.I_SPACE_MANAGER_PAGES_NUM_COUNTING,
						space: space
					}
				}, node);
				this._spaceItems.push(spaceItem);
				
				if (this._isHiddenSpace(space)) {
					dojo.addClass(spaceItem.domNode, "hidden_space");
					var len = 150;
					if (this.spaceUtil.isHomeSpace(space.getID())){
						len = 100;
					}
					var truncateNode=dojo.query("._titleDiv span[class='title']",spaceItem.domNode)[0];
					spaceItem.truncateNodeText(truncateNode ,len, "title", {fontSize:"14px"});
				}
				
				//if there is filter keyword
				var filterDijit = dijit.findWidgets(dojo.query(".filter_spaces")[0])[0];
				if (filterDijit._userEntered && filterDijit._inputNode.value) {
					dojo.publish(this._constants.Topic.Space.filter, [filterDijit._inputNode.value]);
				}
			}
		}
		
		mpHandler.endTransactionDeferred().start();
		
		if (!hasSpaces) {
			containerNode.innerHTML = this._bundle.I_SPACE_MANAGER_NO_SPACES_FOUND;
		}
	},
	
	createSpace : function(space){
		if(this.domNode.childNodes.length == 1){
				if(this.domNode.childNodes[0].nodeType == 3){
					this.domNode.innerHTML = "";
				}
			}
		
		var _self = this;
		var bindNode = dojo.create("div",{}, this.domNode);
		var spaceItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceItem({
			spaceMeta: {
				title: _self.enablerUtil.getNodeTitle(space) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
				description: _self.enablerUtil.getNodeDescription(space) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
				iconUrl: _self.spaceUtil.getSpaceIconURL(space),
				owner: _self.spaceManagerUtil.model.getSpaceOwner(space),
				pagesNum: _self._bundle.I_SPACE_MANAGER_PAGES_NUM_COUNTING,
				space: space
			}
		}, bindNode);			
		this._spaceItems.push(spaceItem);
		
		if (space.isHidden()) {
			dojo.addClass(spaceItem.domNode, "hidden_space");
		} 			
		var truncateNode=dojo.query("._titleDiv span[class='title']",spaceItem.domNode)[0];
		spaceItem.truncateNodeText(truncateNode ,350, "title", {fontSize:"14px"});

		//if there is filter keyword
		var filterDijit = dijit.findWidgets(dojo.query(".filter_spaces")[0])[0];
		if (typeof(filterDijit._inputNode)!= "undefined" && filterDijit._userEntered && filterDijit._inputNode.value) {
			dojo.publish(this._constants.Topic.Space.filter, [filterDijit._inputNode.value]);
		}
		
		if (dojo.style(spaceItem.domNode, "display") != "none") {
			dijit.scrollIntoView(dojo.byId("spaces_list_bottom"));
		}
		
	}
});

}
