if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringItem"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringItem"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.WiringItem");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

/**
 * The WiringItem widget, serve as the thumb of each widget in the overview graph
 */
dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.WiringItem", [dijit._Widget, dijit._Templated],
{
	
	templatePath: dojo.moduleUrl("com.ibm.mm.builder.iwidget.wiringscreen", "templates/wiringItem.html"),
	
	id:"",
	icon:null,
	name:null,
	title:null,
	originalname:null,
	parents:null,
	childrenArray:null,
	visibility:true,
	position: {x:0, y:0},
	maxNameLength: 12,
	cutLength: 9,
	IEMaxNameLength: 12,
	defaultName: "Mashups Widget",
	isSelected:false,
	widgetNameStyleName: "itemname",
	
	postCreate : function(){
		var locale = dojo.locale;
		if(locale && (locale.indexOf("zh-tw") === 0 || 
		   locale.indexOf("ja") === 0 || 
		   locale.indexOf("ko") === 0)){
			this.maxNameLength = 6;
			this.cutLength = 4;
			this.IEMaxNameLength = 6;
		}
		this._setWidgetName();
		this._setWidgetImage();
		this._setImageBackground();
		this.domNode.setAttribute("id", this.id + "_overviewgraph_item");
	},
	
	/**
	 * set the widget name style
	 */
	_setWidgetName: function(){
		this.textNode.innerHTML = this.title || this.defaultName;
		com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(this.textNode, null, {fontSize:"1.2em",fontWeight:"bold"});
		
		if(this.isSelected){
			this._setWidgetNameStyle("selected");
		}else if(this.visibility){
			this._setWidgetNameStyle("visible");
		}else{
			this._setWidgetNameStyle("hidden");
		}
	},
	
	/**
	 * set the widget name style
	 */
	_setWidgetNameStyle: function(classPrefix){
		com.ibm.mm.builder.utils.htmlUtil.addClass(this.textNode, classPrefix + this.widgetNameStyleName);
	},
	
	/**
	 * set the image of the widget item
	 */
	_setWidgetImage: function(){
		var image = document.createElement("img");
		image.setAttribute("src",this.icon);
		dojo.attr(image, "width", 19);
		dojo.attr(image, "height", 19);
		this.imageNode.appendChild(image);
		this.imageNode.setAttribute("id", this.id + "_overviewgraph_item_icon");
		this.imageNode.title = this.title || this.defaultName;
		image.alt = this.title || this.defaultName;
	},
	
	/**
	 * set the class as the hidden/visible style
	 */
	_setImageBackground: function(){
		if(this.visibility){
			com.ibm.mm.builder.utils.htmlUtil.addClass(this.imageNode, "visibleitembackground");
		}else{
			com.ibm.mm.builder.utils.htmlUtil.addClass(this.imageNode, "hiddenitembackground");
		}
	},
	
	/**
	 * get the short name of the widget name
	 */
	_getShortName: function(){
		this.originalname = this.title;
		if(!this.title){
			return this.defaultName;
		}
		this.title = dojo.trim(this.title);
		var maxLength = this.maxNameLength;
		if (dojo.isIE) {
			maxLength = this.IEMaxNameLength;
		}
			
		if(this.title.length < maxLength){
			return this.title;
		}else{
			this.title = this.title.substring(0, this.cutLength) + "...";
			return this.title;
		}
	},
	
	/**
	 * get the image dom node
	 */
	getImageNode : function(){
		return this.imageNode;
	}
	
});

}
