dojo.provide("com.ibm.pb.decorations.LayoutDirectionalMoveControls");

dojo.require("com.ibm.pb.decorations.DirectionalMoveControls");

/**
 * Provides controls to move a node between containers or between siblings in its own container
 */
dojo.declare("com.ibm.pb.decorations.LayoutDirectionalMoveControls", com.ibm.pb.decorations.DirectionalMoveControls, {
	
	builderFactory: com.ibm.mashups.builder.model.Factory,
	
	contentsQuery: "> .component-control",
	containerQuery: ".component-container:not(.hiddenWidgetsContainer)",
	
	constructor: function() {
		this.evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
		this.evtSvc.subscribeEvent("com.ibm.mashups.builder.widgetMoved", this, "onChange");
		this.nm = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
	},
	
	getControls: function(node) {
		// if view mode, no move action available
		if(this.builderFactory.getRuntimeModel().getCurrentPage().getPageMode() == "view") { 
			return []; 
		} else {
			var navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
			var widgetAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getWidgetAccessor(navStateModel,node);
			var state = widgetAccessor.getWindowState();
			// if in maximized mode, no move action available
			if (widgetAccessor.MAX == state){
				return []; 
			} else {
				return this.inherited(arguments);
			}
		}
	},
	
	getPostMoveAction: function(node, parentNode, nextSibling) {
		var nodeId = this.layoutParser.extractID(node),
			parentId = this.layoutParser.extractID(parentNode),
			nextId = (nextSibling && this.layoutParser.extractID(nextSibling)) || null,
			pageId, currentNavNode, lm, lmNode, lmParentNode, lmNextNode;
		pageId = this.builderFactory.getRuntimeModel().getCurrentPage().getID();
		currentNavNode = this.nm.find(pageId).start();
		lm = this.nm.getLayoutModel(currentNavNode);
		lmNode = lm.find(nodeId).start();
		lmParentNode = lm.find(parentId).start();
		if(nextId) {
			lmNextNode = lm.find(nextId).start();
		}
		return function(){
			if(lm.confirmInsert(lmNode, lmParentNode, lmNextNode)) {
				lm.insert(lmNode, lmParentNode, lmNextNode);
				if(typeof ibmc !== "undefined") ibmc.publish("my.setDirtyPage", [ true ]);
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
			}
		};
	},
	
	onMove: function(node, refNode, position) {
		this.evtSvc.broadcastEvent("com.ibm.mashups.builder.widgetMoved", this.layoutParser.extractID(node));
	}
});
