dojo.provide("com.ibm.pb.dnd.layout.LayoutMashupCustomRowSource");

dojo.require("com.ibm.pb.dnd.layout.LayoutMashupRowSource");

dojo.declare("com.ibm.pb.dnd.layout.LayoutMashupCustomRowSource", 
		com.ibm.pb.dnd.layout.LayoutMashupRowSource, {
	
	layoutParser: com.ibm.pb.layout.LayoutParser,
	clearDiv: null,
	constructor: function(){
		this.containerID = this.layoutParser.extractID(this.node);
		this.clearDivID = "clear-" + this.containerID;
		this.initClearDiv(this.clearDivID);
		this.node.appendChild(this.clearDiv);
		
//		this.moveWidget = this.evtSvc.subscribeEvent("com.ibm.mashups.builder.widgetMoved", this, "_widgetMoved");
	},
	initClearDiv:function(id){
		this.clearDiv = dojo.query(".ibmClearRow", this.node)[0];
		if(!this.clearDiv){
			this.clearDiv = dojo.doc.createElement("div");
		}
		dojo.attr(this.clearDiv, {
			"id": id,
			"class": "ibmClearRow"
		});
	},
	removeClearDiv: function(){
		var temp = dojo.byId(this.clearDivID);
		if (temp) {
			this.node.removeChild(temp);
			this.clearDiv = null;
		}
		temp = null;
	},
	addClearDiv:function(){
		this.initClearDiv(this.clearDivID);
		this.node.appendChild(this.clearDiv);
	},
	updateClearDiv:function(){
		this.clearDiv = null;
		this.clearDiv = dojo.byId(this.clearDivID);
		if(!this.clearDiv){
			this.initClearDiv(this.clearDivID);
		}
		this.node.appendChild(this.clearDiv);
	},
	onDndCancel: function() {
		this.inherited(arguments);
		var clearDiv = dojo.query(".ibmClearRow", this.node)[0];
		if (!clearDiv) {
			this.addClearDiv();
		}
	},
	
	onDrop: function(source, nodes, copy){
		this.removeClearDiv();
		this.inherited(arguments);
	},
	createGhost: function(node, type){	
		// creates ghost on page
		if(type == "Before"){
			var container = node.parentNode;
			container.insertBefore(this.createGhostMarkup(), node);
		}else if (type == "After"){
			var container = node.parentNode;
			container.insertBefore(this.createGhostMarkup(), node.nextSibling);
		}
	},
	removeGhost: function(){
		// removes ghost from page
		var ghost = dojo.byId(this.ghostClass);
		if(ghost){
			var parent = ghost.parentNode;
			parent.removeChild(ghost);
		}
	},
	onOverEvent: function(){
		// create ghost in empty container
		this.inherited(arguments);
		this.active = true;
		if(this.isDragging && dojo.dnd.manager().target){
			if(dojo.query("."+this.ghostClass).length > 0 ){
				this.updateClearDiv();
			}
		}
	},

	destroy: function(){
		this.inherited(arguments);
		this.clearDiv = null;
		this.inherited(arguments);
	},
	
	_widgetMoved: function(iEvent){
		this.inherited(arguments);
		var widgetId = iEvent;
		var nodes = dojo.query(".id-"+widgetId ,this.node);
		if (nodes.length >= 1) {
			var last = this.node.lastChild;
			if(dojo.hasClass(last, "ibmClearRow")){
				//do nothing
			}else{
				this.updateClearDiv();
			}
		}
	}
});

com.ibm.pb.dnd.layout.LayoutMashupCustomRowSource.creator = 
	dojo.hitch(com.ibm.pb.dnd.layout.LayoutMashupCustomRowSource, 
		com.ibm.pb.dnd.layout.LayoutRowSource.creator);

com.ibm.pb.dnd.layout.LayoutMashupCustomRowSource.withHandles = true;
