/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.context.LocalizedContext");

// <INTERFACE>
/**
 * LocalizedContext to get the preferred locale, the default locale, as well as
 * titles and descriptions of localized resources within this localized context.
 * 
 * @ibm-api
 * @ibm-module Base2
 */
dojo.declare("com.ibm.mashups.enabler.context.LocalizedContext", null, {
	/**
	 * Returns the preferred locale of this LocalizedContext.
	 * @ibm-api
	 * @type {String}
	 * @return the preferred locale
	 */
	getPreferredLocale : function() {
	},

	/**
	 * Returns the default locale of this LocalizedContext.
	 * @ibm-api
	 * @type {String}
	 * @return the default locale
	 */
	getDefaultLocale : function() {
	},

	/**
	 * Returns the locale of the localized resource, which matches best the locale set with
	 * the browser.
	 * @ibm-api
	 * @param {com.ibm.mashups.enabler.Localized} localized resource implementing the Localized interface; must not be <code>null</code>
	 * @type {String}
	 * @return the preferred locale. Returns <code>null</code> if no locale is available.
	 */
	getLocale : function(localized) {
	},

	/**
	 * Returns the display locale set with the browser matching the specified locale.
	 * @ibm-api
	 * @param {String} locale; mandatory, must not be <code>null</code>
	 * @type {String}
	 * @return the display locale. Returns <code>null</code> if no display locale is available.
	 */
	getDisplayLocale : function(locale) {
	},

	/**
	 * Returns the title of the localized resource in the locale, which matches best the locale
	 * set with the browser.
	 * @ibm-api
	 * @param {com.ibm.mashups.enabler.Localized} localized resource implementing the Localized interface; must not be <code>null</code>
	 * @type {String}
	 * @return the title string in the preferred locale. Returns <code>null</code> if no locale is available.
	 */
	getTitle : function(localized) {
	},

	/**
	 * Returns the description of the localized resource in the locale, which matches best the
	 * locale set with the browser.
	 * @ibm-api
	 * @param {com.ibm.mashups.enabler.Localized} localized resource implementing the Localized interface; must not be <code>null</code>
	 * @type {String}
	 * @return the description string in the preferred locale. Returns <code>null</code> if no locale is available.
	 */
	getDescription : function(localized) {
	}
});
// </INTERFACE>

dojo.require("com.ibm.mm.enabler.context.LocalizedContextImpl");
