/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.model.state.LayoutAccessor");

//<INTERFACE>
dojo.require("com.ibm.mashups.enabler.model.state.Accessor");
dojo.require("com.ibm.mashups.enabler.model.state.LayoutContainerAccessor");
/**
 * Interface representing a LayoutAccessor. Reserved layout container parameters:
 * "templateURL"  : the reserved parameter for layout template URL.
 * @ibm-spi
 * @ibm-module Base
 */
dojo.declare( "com.ibm.mashups.enabler.model.state.LayoutAccessor", [com.ibm.mashups.enabler.model.state.Accessor], {
    /**
      * @private
      */
    constructor:function (navStateModel, pageId) {
    },
    /**
     * Returns the layout template URL (can be used to determine if the state layout is inconsistent with the page instance layout)
     * @type String
     * @return {String} A url to the layout's template.  Uses dav: endpoint notation, e.g. "dav:filestore/layout-tempates/2ColumnEqual"
     */
    getTemplateURL:function() {
    },
    /**
     * Sets the layout template URL 
     * @param {String} url The layout templateURL.  Uses dav: endpoint notation, e.g. "dav:filestore/layout-tempates/2ColumnEqual"
     * @type LayoutAccessor
     * @return{com.ibm.mashups.enabler.model.state.LayoutAccessor} returns a LayoutAccessor upon success, <code>null</code> upon failure.
     */
    setTemplateURL:function(url) {
    },
    /**
    * Returns the layout container accessor for the specified layout container id in this layout.  (Note: Possibly non-intinutively Layout contains LayoutContainers.) 
    * @param {String} containerId  The layout container id for the desired layout container.
    * @type LayoutContainerAccessor
    * @return {com.ibm.mashups.enabler.model.state.LayoutContainerAccessor} Returns the specified LayoutContainerAccessor upon success, <code>null</code> upon failure.
    */
   getContainerAccessor:function(containerId) {
   },
    /**
     * Removes all layout containers and the template URL (can be used to remove obsolete layout's i.e. when the state layout is not the same as the page instance layout)
     * @param {Array} pageWidgets Set of widgets on page that if in model should have their size removed.  Optional parameter.
     * @type LayoutContainerAccessor
     * @return{com.ibm.mashups.enabler.model.state.LayoutAccessor} Returns a LayoutAccessor upon success, <code>null</code> upon failure.
     */
    removeAll:function(pageWidgets) {
    }

});
//</INTERFACE>
dojo.require("com.ibm.mm.enabler.model.state.LayoutAccessorImpl");

