/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.runtime.skin.DynamicContentFilter");
//dojo..require("com.ibm.mashups.enabler.layout.LayoutNode");
dojo.require("com.ibm.mashups.enabler.runtime.skin.DynamicContentFilterChain");
dojo.require("com.ibm.mashups.enabler.runtime.skin.FilterControl");

/**
 * This filter interface allows for checking and filtering dynamic changes on a runtime skin node
 *
 * @private
 * @ibm-module CoreModel
 * @since 2.4
 */
dojo.declare( "com.ibm.mashups.enabler.runtime.skin.DynamicContentFilter", null, {
	/**
	 * Allows the filter to agree on a new value of a client side dynamic content for the skin it is listening on. See &nbsp; {@link com.ibm.mashups.enabler.runtime.skin.Constants Constants} for dynamic content name constants 
     * <b>Note: a filter should not make state changes on this method, they should only return <code>true</code> or <code>false</code></b>
     * @param {com.ibm.mashups.enabler.layout.LayoutNode} layoutNode Layout Node which contains this skin. Will not be <code>null</code>.
     * @param {String} name name of the client side dynamic content spot to return. May not be <code>null</code>
     * @param {String} oldValue old value of the client side dynamic content spot, <code>null</code> if it does not exist
     * @param {String} newValue new value of the client side dynamic content spot. If <code>null</code>, then the value for this dynamic content spot will be cleared
     * @param {FilterControl} control object used for a filter to disagree.
     * @param {com.ibm.mashups.enabler.runtime.skin.DynamicContentFilterChain} filterChain filter chain used to call the next filter in the chain
	 */
	onChangingDynamicContent: function(layoutNode, name, oldValue, newValue, control, filterChain) {
	},
	
	/**
     * allows the filter to take action on the new value of a client side dynamic content for the skin. See &nbsp; {@link com.ibm.mashups.enabler.runtime.skin.Constants Constants} for dynamic content name constants
     * @param {com.ibm.mashups.enabler.layout.LayoutNode} layoutNode Layout Node which contains this skin. Will not be <code>null</code>.
     * @param {String} name name of the client side dynamic content spot to return. May not be <code>null</code>
     * @param {String} oldValue old value of the client side dynamic content spot, <code>null</code> if it does not exist
     * @param {String} newValue new value of the client side dynamic content spot. If <code>null</code>, then the value for this dynamic content spot will be cleared
     * @param {com.ibm.mashups.enabler.runtime.skin.DynamicContentFilterChain} filterChain filter chain used to call the next filter in the chain
     * @type void
     */
    onChangeDynamicContent: function(layoutNode, name, oldValue, newValue, filterChain) {
    }
});
